/* Problem URL: https://codeforces.com/edu/course/2/lesson/2/1/practice/contest/269100/problem/A */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 0

void solve()
{
    string a;
    cin >> a;

    a.push_back('$');

    int n = a.size();

    int log = 1;
    if (n > 1) {
        log = 32 - __builtin_clz(n - 1);
    }

    vvi suffix(log + 1, vi(n));
    rep(i, n) {
        suffix[0][i] = i;
    }

    sort(all(suffix[0]), [&](int i, int j){
         return a[i] < a[j];
         });

    vi prev(n);
    nrep(i, 1, n) {
        if (a[suffix[0][i]] == a[suffix[0][i - 1]]) {
            prev[suffix[0][i]] = prev[suffix[0][i - 1]];
            continue;
        }

        prev[suffix[0][i]] = prev[suffix[0][i - 1]] + 1;
    }

    V<tuple<int, int, int>> cur(n);

    nrep(j, 1, log + 1) {
        rep(i, n) {
            int next = (i + (1 << (j - 1))) - n * ((i + (1 << (j - 1))) >= n);

            cur[i] = {prev[i], prev[next], i};
        }

        sort(all(cur), [&](tuple<int, int, int> &a, tuple<int, int, int> &b){
             auto [ai, aj, ak] = a;
             auto [bi, bj, bk] = b;

             if (ai == bi) {
                return aj < bj;
             }
             return ai < bi;
             });

        prev[get<2>(cur[0])] = 0;
        suffix[j][0] = get<2>(cur[0]);
        nrep(i, 1, n) {
            auto [ai, aj, ak] = cur[i];
            auto [bi, bj, bk] = cur[i - 1];

            suffix[j][i] = ak;

            if (ai == bi && aj == bj) {
                prev[ak] = prev[bk];
                continue;
            }

            prev[ak] = prev[bk] + 1;
        }
    }

    cout << suffix[log];
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
